package com.dky.generate;

import cn.hutool.json.JSONObject;
import com.dky.calculate.Advantage;
import com.dky.calculate.Overall;
import com.dky.calculate.RequireDevice;
import com.dky.entity.Heatboiler;
import com.dky.modelI.DntdModelI;
import com.dky.tool.ModelTool;
import com.dky.utils.entity.DevPrice;
import com.dky.utils.entity.DevSpec;
import com.dky.utils.result.MatchedDevice;
import com.dky.utils.result.MatchedDeviceResult;

import java.util.*;

public class HeatBoilerSence implements DntdModelI {
    @Override
    public JSONObject createReport(JSONObject jsonObject) {
        JSONObject jsonReport = new JSONObject();
        Heatboiler heatboiler = jsonObject.toBean(Heatboiler.class);
        //生成报告
        List<DevSpec> specList = ModelTool.specList;
        List<DevPrice> priceList = ModelTool.priceList;
        MatchedDeviceResult matchedDeviceResult = RequireDevice.matchDevices(heatboiler.getHotDevicePower(), specList, priceList);
        Overall overall = new Overall();
        //初次投资费用（万元）
        Double firstInvestFee = Math.round(matchedDeviceResult.getTotalPriceInTenThousand()*100.0)/100.0;
        //年运行费用（万元）
        Double yearRunFee = Math.round(overall.yearRunFee(heatboiler.getYearEnergy(), heatboiler.getElectricityPrice())*100.0)/100.0;
        //年总费用（万元）
        Double yearTotalFee = Math.round(overall.yearTotalFee(yearRunFee)*100.0)/100.0;
        //年减碳（吨）
        Double yearReduceCarbon = Math.round(overall.yearReduceCarbon(heatboiler.getYearEnergy())*100.0)/100.0;
        //替代电量
        Double replaceEnergy = Math.round(overall.replaceEnergy(heatboiler.getYearEnergy())*100.0)/100.0;
        List<MatchedDevice> devices = matchedDeviceResult.getMatchedDevices();
        //需配置设备情况
        //方案详情
        String reportDetail = "用直热式电锅炉替代原设备";
        /*//设备类型
        String deviceType = "";
        //设备规格
        String deviceSpec = "";
        //设备数量
        String deviceNum = "";*/
        //单位（元/台、元/套）
        String unit = "";
        Set<String> devTypeSet = new HashSet<>();
       /* for (MatchedDevice matchedDevice : matchedDeviceResult.getMatchedDevices()) {
            devTypeSet.add(matchedDevice.getDevSpec().getDevType());
            deviceSpec = deviceSpec + matchedDevice.getDevSpec().getDevType() + ":"+matchedDevice.getDevSpec().getCapacity()+"蒸吨、";
            deviceNum = deviceNum + matchedDevice.getCount() + "台/"+matchedDevice.getDevSpec().getDevType()+";";
            int devId = matchedDevice.getDevSpec().getId();
            for (DevPrice devPrice : priceList) {
                if (devId == devPrice.getId()) {
                    unit = unit+devPrice.getDevPrice()+"元/台；";
                    break;
                }
            }
        }*/
       /* for (String s : devTypeSet) {
            deviceType = deviceType + s + "、";
        }*/
        Advantage advantage = new Advantage();
        //总价
        String totalPrice = matchedDeviceResult.getTotalPriceInTenThousand()+"万元";
        jsonReport.put("firstInvestFee", firstInvestFee);
        jsonReport.put("yearRunFee", yearRunFee);
        jsonReport.put("yearTotalFee", yearTotalFee);
        jsonReport.put("yearReduceCarbon", yearReduceCarbon);
        jsonReport.put("replaceEnergy", replaceEnergy);
        jsonReport.put("reportDetail", reportDetail);
        /*jsonReport.put("deviceType", deviceType);
        jsonReport.put("deviceSpec", deviceSpec);*/
        jsonReport.put("devices", devices);
        jsonReport.put("unit", unit);
        jsonReport.put("totalPrice", totalPrice);
        jsonReport.put("safety", advantage.safety());
        jsonReport.put("economy", advantage.economy(firstInvestFee,yearTotalFee,yearRunFee,heatboiler.getOriginalDevice().getLastYearFee()));
        jsonReport.put("intelligence", advantage.intelligence());
        jsonReport.put("environment", advantage.environment(yearReduceCarbon));
        return jsonReport;
    }
}
